/* powerlist.c */
/* $Id: powerlist.c,v 1.13 1993/05/27 23:17:43 nils Exp $ */

#include "db.h"
#include "powers.h"
#include "externs.h"

#define NO PW_NO
#define YES PW_YES
#define YESLT PW_YESLT
#define YESEQ PW_YESEQ
  
  
/* Tchnmg Electr Cnstctr  Dfndr Citzen  Vistr Guest  Guide pCtzen Group */
struct pow_list powers[]={
  {
    "Allquota", POW_ALLQUOTA, "Ability to alter everyone's quota at once",
    {NO,     NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Announce", POW_ANNOUNCE, "Ability to @announce for free",
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES }},
  {
    "Boot", POW_BOOT, "Ability to @boot players off the game",
    {YES,    YESLT, NO,    YESLT, NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YESLT, YESLT, YESLT, NO,    NO,    NO,    YESLT,YESLT,NO }},
  {
    "Broadcast", POW_BROADCAST, "Ability to @broadcast a message",
    {YES,    YES,   NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   YES,  NO }},
  {
    "Chown", POW_CHOWN, "Ability to change ownership of an object",
    {YESEQ,  YESEQ, YESEQ, YESLT, NO,    NO,    NO,    NO,   NO,   NO },
    {YESEQ,  YESEQ, YESEQ, YESLT, NO,    NO,    NO,    YESLT,YESEQ,YESEQ }},
  {
    "Class", POW_CLASS, "Ability to re@classify somebody",
    {YESLT,  NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YESLT,  NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Database", POW_DB, "Ability to use @dbck and other database utilities",
    {YES,    YES,   NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   YES,  NO }},
  {
    "Examine", POW_EXAMINE, "Ability to see people's homes and locations",
    {YES,    YESEQ, YESEQ, YESEQ, NO,    NO,    NO,    YESLT, NO,   NO },
    {YES,    YESEQ, YESEQ, YESEQ, NO,    NO,    NO,    YESEQ, YESLT,YESEQ}},
  {
    "Free", POW_FREE, "Ability to build, etc. for free",
    {YES,    YES,   YES,   NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES }},
  {
    "Who", POW_WHO, "Ability to see classes and hidden players on the WHO list",
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES}},
  {
    "Outgoing", POW_OUTGOING, "Ability to initiate net connections.",
    {NO,     NO,    NO,    NO,     NO,   NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,    NO,   NO,    NO,    YES,  YES,  YES}},
  {
    "Join", POW_JOIN, "Ability to 'join' players",
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES}},
  {
    "Member", POW_MEMBER, "Ability to change your name and password",
    {YES,    YES,   YES,   YES,   YES,   NO,    NO,    YES,  YES,  YES},
    {YES,    YES,   YES,   YES,   YES,   NO,    NO,    YES,  YES,  YES}},
  {
    "Modify", POW_MODIFY, "Ability to modify other people's objects",
    {YESEQ,  YESEQ, YESEQ, YESEQ, NO,    NO,    NO,    NO,   NO,   NO },
    {YESEQ,  YESEQ, YESEQ, YESEQ, NO,    NO,    NO,    YESEQ,YESEQ,YESEQ }},
  {
    "Money", POW_MONEY, "Power to have INFINITE money",
    {YES,    YES,  YES,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,  YES,    YES,   NO,    NO,    NO,    NO,   YES,  YES}},
  {
    "Newpassword", POW_NEWPASS, "Ability to use the @newpassword command",
    {YESLT,  YESLT, NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YESLT,  YESLT, NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Noslay", POW_NOSLAY, "Power to not be killed",
    {YES,    YES,   YES,   YES,   NO,    NO,    YES,   YES,  NO,   YES },
    {YES,    YES,   YES,   YES,   NO,    NO,    YES,   YES,  YES,  YES}},
  {
    "Noquota", POW_NOQUOTA, "Power to have INFINITE quota",
    {YES,    YES,   YES,   NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   NO,   YES }},
  {
    "Nuke", POW_NUKE, "Power to @nuke other characters",
    {YESLT,  NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YESLT,  YESLT, NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Pcreate", POW_PCREATE, "Power to create new characters",
    {YES,    YES,   NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   NO,    NO,    NO,    NO,    NO,    NO,   YES,  NO }},
  {
    "Poor", POW_POOR, "Power to use the @poor command",
    {NO,     NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Queue", POW_QUEUE, "Power to see everyone's commands in the queue",
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES}},
  {
    "Exec", POW_EXEC, "Power to execute external programs",
    {NO,     NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   NO,    NO,    NO,    NO,    NO,   YES,  NO }},
  {
    "Seeatr", POW_SEEATR, "Ability to see attributes on other people's things",
    {YES,    YESEQ, YESEQ, YESEQ, NO,    NO,    NO,    YESEQ,NO,   NO },
    {YES,    YESEQ, YESEQ, YESEQ, NO,    NO,    NO,    YESEQ,YESEQ,YESEQ}},
  {
    "Setpow", POW_SETPOW, "Ability to alter people's powers",
    {YESLT,  NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YESLT,  NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Slay", POW_SLAY, "Ability to use the 'slay' command",
    {YES,    YES,   YES,   YESLT, NO,    NO,    NO,    YESLT,NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YESLT,YES,  YES }},
  {
    "Shutdown", POW_SHUTDOWN, "Ability to @shutdown the game",
    {YES,    NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Summon", POW_SUMMON, "Ability to 'summon' other players",
    {YES,    YES,   YES,   YESLT, NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YESEQ, NO,    NO,    NO,    YESLT,YES,  YES}},
  {
    "Slave", POW_SLAVE, "Ability to set the slave flag.",
    {YESLT,  YESLT, NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YESLT,  YESLT, YESLT, YESLT, NO,    NO,    NO,    YESLT,YESLT,NO }},
  {
    "Spoof", POW_SPOOF, "Ability to do unlimited @emit etc",
    {YES,    YES,   YES,   NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   YES,  YES}},
  {
    "Stats", POW_STATS, "Ability to @stat other ppl",
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES}},
  {
    "Steal", POW_STEAL, "Ability to give negative amounts of credits",
    {YES,    YES,   NO,    YES,   NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES}},
  {
    "Teleport", POW_TELEPORT, "Ability to use unlimited @tel",
    {YES,    YES,   NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   YES,  YES}},
  {
    "WizAttributes", POW_WATTR, "Ability to set Last, Queue, etc",
    {YES,    YES,   NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   YES,  YES }},
  {
    "WizFlags", POW_WFLAGS, "Ability to set Temple, etc",
    {YES,    YES,   NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   YES,  YES }},
  {
    "Remote", POW_REMOTE, "Ability to do remote whisper, @pemit, etc.",
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES}},
  {
    "Security", POW_SECURITY, "Ability to do various security-related things",
    {YES,    NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Incoming", POW_INCOMING, "Ability to connect net to non-players",
    {YES,     NO,    NO,    NO,    NO,   NO,    NO,    NO,  NO,  NO},
    {YES,    YES,   YES,   YES,    NO,   NO,    NO,    YES,  YES,  YES}},
  {
    "Functions", POW_FUNCTIONS, "Ability to get correct results from all functions",
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES}},
  {
    "Dbtop", POW_DBTOP, "Abililty to do a @dbtop",
    {YES,    YES,   NO,    YES,   NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YES,   NO,    YES,   NO,    NO,    NO,    YES,  YES,  NO }},
  {
    "Setquota", POW_SETQUOTA, "Ability to change people's quotas",
    {YES,    NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO },
    {YES,    YESLT, NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO }},
  {
    "Ban", POW_BAN, "Ability to ban/unban people from channels",
    {YES,    YES,   NO,    YES,   NO,    NO,    NO,    YES,  NO,   NO },
    {YES,    YES,   YES,   YES,   NO,    NO,    NO,    YES,  YES,  YES}},
  {
    "HTTP", POW_HTTP, "Ability to send a URL",
   {NO,      NO,    NO,    NO,    NO,    NO,    NO,    NO,   NO,   NO},
   {YES,     YES,   YES,   YES,   YES,   YES,   YES,   YES,  YES,  YES}},
};

static char *classnames[] ={
  " ?",
  "Guest", "Visitor", "Citizen",
  "pCitizen", "Group", "Guide", "Defender", "Constructor",
  "Elector", "Technomage",
  NULL
  };
static char *typenames[] ={
  "Room", "Thing", "Exit", "Universe", " 0x4", " 0x5", " 0x6", " 0x7", "Player"
  };

char *class_to_name(class)
     int class;
{
  if(class >= NUM_CLASSES || class <=0) return NULL;
  return classnames[class];
}

int name_to_class(name)
     char *name;
{
  int k;
  for(k=0;classnames[k];k++)
    if(!string_compare(name,classnames[k]))
      return k;
  return 0;
}
char *type_to_name(type)
     int type;
{
  if(type>=0 && type<9)
    return typenames[type];
  else
    return NULL;
}

int class_to_list_pos(type)
     int type;
{
  switch(type) {
  case CLASS_DIR:
    return 0;
  case CLASS_ADMIN:
    return 1;
  case CLASS_BUILDER:
    return 2;
  case CLASS_OFFICIAL:
    return 3;
  case CLASS_CITIZEN:
    return 4;
  case CLASS_VISITOR:
    return 5;
  case CLASS_GUEST:
    return 6;
  case CLASS_JUNOFF:
    return 7;
  case CLASS_PCITIZEN:
  case CLASS_GROUP:
    return 8;
  default: return 5;
  }
}
